#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define MAX 25

bool hasblacknbr(int xw[][MAX], int m, int n, int i, int j)
{
   return i == 0 || j == 0 || i == m - 1 || j == n - 1 ||
          xw[i - 1][j] == -2 || xw[i][j - 1] == -2 ||
          xw[i + 1][j] == -2 || xw[i][j + 1] == -2;
}

bool hasnumber(int xw[][MAX], int m, int n, int i, int j)
{
    bool v1 = (i == 0 || xw[i - 1][j] < 0) && xw[i][j] == 0 &&
              (i < m - 1 && xw[i + 1][j] >= 0);
    bool v2 = (j == 0 || xw[i][j - 1] < 0) && xw[i][j] == 0 &&
              (j < n - 1 && xw[i][j + 1] >= 0);
    return v1 || v2;
}

char grid[MAX * 3 + 2][MAX * 5 + 2];

void DrawPiece(int xw[][MAX], int i0, int j0)
{
    int type = xw[i0][j0];
    char buf[10];

    if ( type == -2 ) return;

    strncpy(&grid[3 * i0 + 0][5 * j0], "++++++", 6);
    strncpy(&grid[3 * i0 + 3][5 * j0], "++++++", 6);
    if ( type >= 0 ) {
        if ( type > 0 ) sprintf(buf, "+%03d +", type);
            else sprintf(buf, "+    +");
        strncpy(&grid[3 * i0 + 1][5 * j0], buf, 6);
        strncpy(&grid[3 * i0 + 2][5 * j0], "+    +", 6);
    } else {
        strncpy(&grid[3 * i0 + 1][5 * j0], "++++++", 6);
        strncpy(&grid[3 * i0 + 2][5 * j0], "++++++", 6);
    }
}

void PrintLine(char *s, int len)
{
    len = 5 * len + 1;

    s[len--] = 0;
    while ( len >= 0 && s[len] == ' ' ) s[len--] = 0;

    printf("%s\n", s);
}

void DrawXWord(int xw[][MAX], int m, int n)
{
    int i, j;

    // clear those at edge
    bool repclr = true;
    while ( repclr ) {
        repclr = false;
        for ( i = 0; i < m; i++ )
            for ( j = 0; j < n; j++ )
                if ( xw[i][j] == -1 && hasblacknbr(xw, m, n, i, j) ) {
                    xw[i][j] = -2;
                    repclr = true;
                }
    }

    // fill with numbers
    int cnt = 1;
    for ( i = 0; i < m; i++ ) {
        for ( j = 0; j < n; j++ )
            if ( hasnumber(xw, m, n, i, j) )
                xw[i][j] = cnt++;
    }

    // draw
    memset(grid, ' ', sizeof grid);

    for ( i = 0; i < m; i++ ) {
        for ( j = 0; j < n; j++ ) DrawPiece(xw, i, j);
        for ( int i1 = 0; i1 < 3; i1++ )
            PrintLine(grid[3 * i + i1], n);
    }
    PrintLine(grid[3 * m], n);
}

int main()
{
    int m, n;
    int xw[MAX][MAX];

    int cnt = 0;
    while ( true ) {
        scanf(" %d %d", &m, &n);
        if ( m == 0 ) break;
        for ( int i = 0; i < m; i++ )
            for ( int j = 0; j < n; j++ ) {
                scanf(" %d", &xw[i][j]);
                xw[i][j] = -xw[i][j];
            }

        if ( cnt++ > 0 )
            printf("\n--------------------------------------------------\n\n");
        DrawXWord(xw, m, n);
    }

    return 0;
}
