#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

char *words[] =
{
    "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "ten",
    "eleven", "twelve", "thirteen", "fourteen", "fifteen", "sixteen", "seventeen", "eighteen", "nineteen",
    "twenty", "thirty", "forty", "fifty", "sixty", "seventy", "eighty", "ninety",
};

char *printsmall(int n, char *dest)
{
    if ( n >= 100 ) {
        dest += sprintf(dest, "%s hundred ", words[n / 100]);
        n %= 100;
    }

    if ( n == 0 ) ;
    else if ( n < 20 )
        dest += sprintf(dest, "%s ", words[n]);
    else {
        dest += sprintf(dest, "%s ", words[(n - 20) / 10 + 20]);
        if ( n % 10 > 0 )
            dest += sprintf(dest, "%s ", words[n % 10]);
    }
    return dest;
}

void printnum(int n, char *dest)
{
    if ( n < 0 ) {
        dest += sprintf(dest, "negative ");
        n = -n;
    }

    if ( n == 0 )
        dest += sprintf(dest, "zero ");
    else {
        if ( n >= 1000000 ) {
            dest = printsmall(n / 1000000, dest);
            dest += sprintf(dest, "million ");
        }
        n %= 1000000;
        if ( n >= 1000 ) {
            dest = printsmall(n / 1000, dest);
            dest += sprintf(dest, "thousand ");
        }
        n %= 1000;
        if ( n >= 1 )
            dest = printsmall(n, dest);
    }

    dest[strlen(dest) - 1] = '\0';
}

int Rand()
{
    return rand() * 0x8000 + rand();
}

int main()
{

    char dest[256];

    for ( int i = 0; i < 10000; i++ ) {
        int n = Rand() % 1000000000 - 300000000;
        if ( i < 2000 ) n = rand() % 19000;
        if ( i < 200 ) n = i;

        printnum(n, dest);
        printf("%s\n", dest);
        //printf("%d\n", n);
    }

    return 0;
}
