#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

int Rand(int n) {
    return (int)(rand() / (RAND_MAX + 1.0) * n);
}

struct Node
{
    Node *left, *right;
    char text[8];
    int freq;

    Node(char *ntext) {
        left = right = NULL;
        freq = 1;
        strcpy(text, ntext);
    }
};

Node *Insert(Node *&node, char *text)
{
    if ( node == NULL )
        return node = new Node(text);

    int c = strcmp(text, node->text);

    if ( c == 0 ) {
        node->freq++;
        return node;
    }

    if ( c > 0 ) return Insert(node->right, text);
        else return Insert(node->left, text);
}

Node *Tree[6];

void AddText(char *text)
{
    int i, len;
    char s[8];
    int tlen = strlen(text);
    
    for ( i = 0; i < tlen; i++ ) 
        text[i] = toupper(text[i]);

    for ( len = 1; len <= 5; len++ ) {
        for ( i = 0; i + len <= tlen; i++ ) {
            strncpy(s, text + i, len);
            s[len] = 0;
            Insert(Tree[len], s);
        }
    }
}

void GetMaxFreqs(int top[], Node *node)
{
    if ( node == NULL ) return;

    int i, j;
    for ( i = 5; i > 0 && node->freq >= top[i - 1]; i-- );
    if ( node->freq > top[i] ) {
        for ( j = 4; j > i ; j-- ) top[j] = top[j - 1];
        top[i] = node->freq;
    }

    GetMaxFreqs(top, node->left);
    GetMaxFreqs(top, node->right);
}

char *FreqRepDelim = "";

void PrintFreqRep(Node *node, int freq)
{
    if ( node == NULL ) return;

    PrintFreqRep(node->left, freq);
    if ( node->freq == freq ) {
        printf("%s%s", FreqRepDelim, node->text);
        FreqRepDelim = ",";
    }
    PrintFreqRep(node->right, freq);
}

void PrintTree(Node *node)
{
    if ( node == NULL ) return;

    PrintTree(node->left);
    printf("(%s:%d) ", node->text, node->freq);
    PrintTree(node->right);
}

int main()
{
    int i;
    char word[256];
    int top[8];

    for ( i = 0; i <= 5; i++ ) Tree[i] = NULL;

    while ( true ) {
        scanf("%*[^a-zA-Z]");
        if ( scanf("%[a-zA-Z]", word) < 1 ) break;
        AddText(word);
    }

    for ( int len = 1; len <= 5; len++ ) {
        for ( i = 0; i <= 5; i++ ) top[i] = 0;
        GetMaxFreqs(top, Tree[len]);
        //PrintTree(Tree[len]);

        printf("Analysis for Letter Sequences of Length %d\n", len);
        printf("-----------------------------------------\n");
        for ( i = 0; i < 5 && top[i] > 0; i++ ) {
            printf("Frequency = %d, Sequence(s) = (", top[i]);
            FreqRepDelim = "";
            PrintFreqRep(Tree[len], top[i]);
            printf(")\n");
        }
        /**/
        printf("\n");

    }

    return 0;
}
